#include "config.h"

/*
// dying loop
int expLength = 8;
char *expLoop[] = {
"            1111g       ",
"            a   c       ",
"            a   c       ",
"            a   c       ",
"            a   c       ",
"            a   c       ",
"            a   c       ",
"            ah3333333   ",
};
*/

/*
// evo loop
/*
  N is the number of a,c lines (thus expLength=N+2).
  - With N=5, evolution process occurs and small loops
  with only one turn gene are produced.
  - The simulation dies immediately with N=6.
  - With N=7, winning loops have 2 turn genes.
  - Simulation is stuck on one unique loop with N=8.
  - Simulation dies immediately with N=9, N=10.
  - Simulation lives with N=11.
  - Simulation dies with N=12, N=13.
  - Simulation stays cyclic with a small number of loops, with N=14, N=15, N=16.
  - Simulation dies with N=17, N=18, N=19
*/

/*
// basic evo loop
int expLength = 7;
char *expLoop[] = {
"     111g              ",
"     a  c              ",
"     a  c              ",
"     a  c              ",
"     a  c              ",
"     a  c              ",
"     e3333333         ",
};
*/

/*
// simulation dies
int expLength = 5;
char *expLoop[] = {
"     11b1g              ",
"     0   2              ",
"     a   c              ",
"     0   2              ",
"     e3d333333333         ",
};
*/


// exiting loop
int expLength = 14;
char *expLoop[] = {
"9999999999999999999999",
"9                    9",
"9                    9",
"9                    9",
"9      1111g         9",
"9      a   c         9",
"9      a   c         9",
"9      a   c         9",
"9      a   c         9",
"9      a333333       9",
"9                    9",
"9                    9",
"9                    9",
"9999999999999999999999",
};



/*
// living loops (inside square
int expLength = 41;
char *expLoop[] = {
"999999999999999999999999999999999",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"                                9",
"                                9",
"                                9",
"                                9",
"                                9",
"       11fc                     9",
"       0  c                     9",
"       0  2                     9",
"9      0333333                  9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"999999999999999999999999999999999",  
};
*/
/*
// living loops
int expLength = 41;
char *expLoop[] = {
"999999999999999999999999999999999",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9      11fc                     9",
"9      0  c                     9",
"9      0  2                     9",
"9      0333333                  9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"9                               9",
"999999999999999999999999999999999",  
};
*/
/*
// exiting loop
int expLength = 16;
char *expLoop[] = {
"999999999999999999999999999",
"9                         9",
"9                         9",
"9                         9",
"9                         9",
"       1111g              9",
"9      a   c              9",
"9      a   c              9",
"9      a   c              9",
"9      a   c              9",
"9      a   c              9",
"9      a333333            9",
"9                         9",
"9                         9",
"9                         9",
"99999 999999999999999999999",
};
*/
// 
/*
int expLength = 4;
char *expLoop[] = {
"11jc   ",
"0  c   ",
"0  2   ",
"0333333",
};
*/
/////////////////////////////////////////////////
/*
// one clk and one invclk loop: the left is winning
int expLength = 4;
char *expLoop[] = {
"11fc      11jc   ",
"0  c      0  c   ",
"0  2      0  2   ",
"0333333   0333333",
};
*/

/*
// 38K instants: no more left loops
int expLength = 4;
char *expLoop[] = {
"   23dd      11fc ",
"   2  i      0  c",
"   2  0      0  2",
"1111110      0333333",
};
*/
/*
int expLength = 4;
char *expLoop[] = {
"   23dd      11jc ",
"   2  e      0  c",
"   2  0      0  2",
"1111110      0333333",
};
*/

#define Grow "dd"
#define C Grow "l3"
#define I Grow "h3"
// small invclk loops
#define SC C C C "33" C C C C
// small clk loops
#define SI I I I "33" I I I I

#define T1 C I I "3d3"
#define T2 I C C "333"
//#define Test "3d3d3"  T1 "3ddlddlddl3ddh333" T2 T2 T2 T2 T2

//#define S C C "333" C C C C "3333dh3" SI // the red loops win
//#define S I I "333" I I I I "dh3" SC // the blue loops win

//#define S SI "3333333333333333" SI "3333333333333333" SC

#define Start "l3"
#define End "333"
#define Grow6 "dddddd"
#define Grow5 "ddddd"
#define Grow4 "dddd"
#define Grow3 "ddd"
#define Grow2 "dd"
#define Side "3333" Grow6 "h3"
//#define S End Side Side Side Side Side Start
#define Side12 "33333333" Grow6 Grow6 "h3"
#define Side10 "333333" Grow5 Grow5 "h3"
#define Side6 "3333" Grow6 "h3"
#define Side5 "3333" Grow5 "h3"
#define Side3 "333" Grow3 "h3"
#define Side2 "33" Grow2 "h3"

//#define S End Side12 Side6 Side5 Side3 Side12 Start
//#define S End Side12 Side2 Side12 Side2 Side12 Start
//#define S End Side12 Side3 Side12 Side3 Side12 Start
//#define S End Side12 Side6 Side3 Side5 Side10 Start
//#define S End Side12 Side6 Side3 Side6 Side12 Start
#define S End Side12 Side3 Side12 Side3 Side10 Start

/*
int expLength = 1;
char *expLoop[] = {
S,
};
*/

//"ddh3ddh3ddh333ddh3ddh3ddh3ddh3" // small invclk loops
//"ddh3ddl3ddl333ddh3ddh3ddh3ddh3",// small clk loops
//"ddh3ddl3ddl333ddl3ddl3ddl3ddh3",// small clk loops
   
/*
// the clk gene (i) is eliminated after some time
int expLength = 8;
char *expLoop[] = {
"            1111g       ",
"            a   c       ",
"            i   c       ",
"            a   c       ",
"            a   c       ",
"            a   c       ",
"            a   c       ",
"            ah3333333   ",
};
*/
/*
// the turn genes (h,g) are eliminated after some time (4660)!
int expLength = 8;
char *expLoop[] = {
"            1111g       ",
"            a   c       ",
"            a   c       ",
"            a   k       ",
"            a   c       ",
"            a   c       ",
"            a   c       ",
"            ah3333333   ",
};
*/


/*
// 
int expLength = 8;
char *expLoop[] = {
"            1111g       ",
"            a   c       ",
"            a   c       ",
"            a   c       ",
"            a   c       ",
"            a   c       ",
"            a   k       ",
"            ah3333333   ",
};
*/

/*
int expLength = 17;
char *expLoop[] = {
"                      ",
"                       ",
"                        ",
"               bb2       ",
"               a 2       ",
"             b1i 112       ",
"             a     2       ",
"             adh g3d     ",
"               0 2     ",
"               03d     ",
"                0     ",
"                0     ",
"                0     ",
"                0333333333333     ",
"                      ",
"                      ",
"                      ",
};
*/
/*
// 
int expLength = 8;
char *expLoop[] = {
"            1111g       ",
"            a   c       ", // simulation dies
"            a   c       ", // loop cannot reproduce
"            a   c       ", // g,h genes are eliminated
"            a   k       ", // simulation dies
"            a   c       ", // simulation dies
"            a   c       ", // k eliminated
"            ah3333333   ",
};
// without any k, the simulation dies
*/
#include "env.h"
void build_simulation (void)
{
   int i,n;
   for (n = 0; n < MAXY; n++) {
      initialize (MAXX/2,n,WALL,BASIC);
   }

    //build_loop (expLength,expLoop,MAXX/2,MAXY/2);
   
}
